#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Green
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Chocolate
#property indicator_color5 Maroon
#property indicator_color6 Orange
#property indicator_color7 Purple
#property indicator_color8 Teal
//+------------------------------------------------------------------+
extern int  Period_fast = 12;
extern int  Period_slow = 26;
extern int  chart_minutes = 0;
extern bool Once_per_Bar = true;
//----
double arr0[];
double arr1[];
double arr2[];
double arr3[];
double arr4[];
double arr5[];
double arr6[];
double arr7[];
//----
int MA_Method = 3;
int Price_mode = 4;
datetime bartime=0;
//----
int pairs_Prefixes, multi[],NUM_PAIRS,NUM_CURENCIES,pnt;
string PAIRS[],CURENCIES[];
bool error;
//+------------------------------------------------------------------+
int init()
  {
   RefreshRates();
   error=false;
   symbolsFromBrokers();
   if(NUM_PAIRS<1) return(-1);
   normalizeDigits();
   pairsPrefix();
   extractCurencies();
   if(NUM_CURENCIES<1 || error) return(-1);
//---- 
   SetIndexBuffer(0, arr0);
   SetIndexLabel(0, CURENCIES[0]); 
   SetIndexBuffer(1, arr1);
   if(NUM_CURENCIES>1) SetIndexLabel(1, CURENCIES[1]); 
   SetIndexBuffer(2, arr2);
   if(NUM_CURENCIES>2) SetIndexLabel(2, CURENCIES[2]); 
   SetIndexBuffer(3, arr3);
   if(NUM_CURENCIES>3) SetIndexLabel(3, CURENCIES[3]); 
   SetIndexBuffer(4, arr4);
   if(NUM_CURENCIES>4) SetIndexLabel(4, CURENCIES[4]); 
   SetIndexBuffer(5, arr5);
   if(NUM_CURENCIES>5) SetIndexLabel(5, CURENCIES[5]); 
   SetIndexBuffer(6, arr6);
   if(NUM_CURENCIES>6) SetIndexLabel(6, CURENCIES[6]); 
   SetIndexBuffer(7, arr7);
   if(NUM_CURENCIES>7) SetIndexLabel(7, CURENCIES[7]); 
//----
   IndicatorShortName("Smoothed indexes: ");
   Print("found ",NUM_CURENCIES," curencies ", NUM_PAIRS," pairs");
   return(0);
  }
//+------------------------------------------------------------------+
int deinit() { Comment(""); return(0); }
//+------------------------------------------------------------------+
int start()
  {
   if(Once_per_Bar && bartime==Time[0]) return(0);
   bartime=Time[0]; 
   double index; 
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   int value, limit = Bars - counted_bars;
   for(int x=0;x<limit;x++)
   {
    for(int i=0;i<NUM_CURENCIES;i++)
    {
      index = 0.0;
      value=0;
      for (int z=0;z<NUM_PAIRS;z++)
      {
         if(StringFind(PAIRS[z], CURENCIES[i]) < 0) continue;
         bool lower = StringFind(StringSubstr(PAIRS[z], pairs_Prefixes, 3), CURENCIES[i]) > -1;
         double pips = (iMA(PAIRS[z], chart_minutes, Period_fast, 0, MA_Method, Price_mode, x+Once_per_Bar)
                      - iMA(PAIRS[z], chart_minutes, Period_slow, 0, MA_Method, Price_mode, x+Once_per_Bar)) * multi[z];
         //double pips_weight = pips * iVolume(PAIRS[z], chart_minutes, x+Once_per_Bar);
         if (lower) { index += pips; value++; }
         else { index -= pips; value--; }
      }
      if(value!=0) index /=value;
      if(i==0) arr0[x]=index;
      else if(i==1) arr1[x]=index;
      else if(i==2) arr2[x]=index;
      else if(i==3) arr3[x]=index;
      else if(i==4) arr4[x]=index;
      else if(i==5) arr5[x]=index;
      else if(i==6) arr6[x]=index;
      else if(i==7) arr7[x]=index;
    }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
void symbolsFromBrokers()
 {
  int saf = FileOpenHistory("symbols.raw",FILE_BIN|FILE_READ);
  if ( saf<1 ) { Comment( "ERROR simbols.raw" ); return; }
  string tmps = ""; 
  bool ret; 
  pnt=0; 
  NUM_PAIRS=0; 
  ArrayResize( PAIRS, 0 );
  int Z=FileSize(saf) / 1936;
  for ( int c=0;c<Z;c++ )
   {
    tmps = FileReadString(saf, 12);
    FileSeek(saf, 1924, SEEK_CUR);
    ret = checkSymbol( tmps );
    if ( !ret ) continue;
    NUM_PAIRS++;
    ArrayResize(PAIRS, NUM_PAIRS);
    PAIRS[NUM_PAIRS-1] = tmps;
   }
  FileClose(saf);
  return;
 }
//+------------------------------------------------------------------+
bool checkSymbol(string c_symbol)
 {
  if(StringFind(c_symbol,"XAU")>-1 || StringFind(c_symbol,"XAG")>-1) return(false);
  for(int d=0;d<NUM_PAIRS;d++) if(StringFind(c_symbol,PAIRS[d])>-1) return(false);
  int s_type=MathMax(MarketInfo(c_symbol,27),MarketInfo(c_symbol,28));
  if(MarketInfo(c_symbol,9)>0 && MarketInfo(c_symbol,10)>0.0 && s_type==0)
  {
   if (pnt<1)
    { pnt=1; if (MarketInfo(c_symbol,12)==3 || MarketInfo(c_symbol,12)==5) pnt=10; }
   return(true);
  }
  return(false);
 }
//+------------------------------------------------------------------+
void normalizeDigits()
  {
   ArrayResize(multi,NUM_PAIRS);
   for(int z=0;z<NUM_PAIRS;z++)
   {
    int d = MarketInfo(PAIRS[z], MODE_DIGITS);
    if (pnt>1) d -= 1;
    multi[z] = 1.0;
    for (int x = 0; x < d; x++) multi[z] *= 10.0;
   }
   return;
  }
//+------------------------------------------------------------------+
void pairsPrefix()
  {
   for (int z = 0; z < NUM_PAIRS; z++)
   {
    pairs_Prefixes =StringFind(PAIRS[z],"GBP");
    if(pairs_Prefixes > -1 && pairs_Prefixes < 3) break;
   }
   if(pairs_Prefixes<0 || pairs_Prefixes>2) error=true;
   return;
  }
//+------------------------------------------------------------------+
void extractCurencies()
  {
   NUM_CURENCIES=0; 
   ArrayResize(CURENCIES,NUM_CURENCIES);
   string tmps; 
   for(int d=0;d<NUM_PAIRS;d++)
   {
    tmps=StringSubstr(PAIRS[d], pairs_Prefixes, 3); 
    if(searchCurency(tmps)) continue;
    NUM_CURENCIES++;
    ArrayResize(CURENCIES, NUM_CURENCIES);
    CURENCIES[NUM_CURENCIES-1] =tmps;
   }
   //-----
   for(d=0;d<NUM_PAIRS;d++)
   {
    tmps=StringSubstr(PAIRS[d], pairs_Prefixes+3, 3); 
    if(searchCurency(tmps)) continue;
    NUM_CURENCIES++;
    ArrayResize(CURENCIES, NUM_CURENCIES);
    CURENCIES[NUM_CURENCIES-1] =tmps;
   }
   return;
  }
//+------------------------------------------------------------------+
bool searchCurency(string stmps="")
  {
   for(int z=0;z<NUM_CURENCIES;z++)
    if(StringFind(CURENCIES[z],stmps)>-1) return(true);
   return(false);
  }
//+------------------------------------------------------------------+


